# $Id: excel.tcl,v 1.4 1999/07/26 22:39:24 chuang Exp $
#
# This example shows how to write an event sink.
# It performs the following steps.
#       - Start Excel application.
#       - Create a new workbook.
#       - Exit Excel application.
# Excel should fire the NewWorkbook event when a new workbook is created.
#
# This example requires the Excel type library.  It assumes the excel8.olb
# type library file is in the current working directory.

package require tcom
::tcom::import excel8.olb

proc sink {method args} {
    puts "event $method $args"
}

proc doUpdate {comment} {
    puts "invoked $comment"
    update
}

set application [::Excel::Application -withevents sink]
$application Visible 1

set workbooks [$application Workbooks]
doUpdate "Workbooks"
set workbook [$workbooks Add]
::tcom::bind $workbook sink $::Excel::__uuidof(WorkbookEvents)
doUpdate "Add"
$application Quit
doUpdate "Quit"

::tcom::release $workbook $workbooks $application
