// $Id: ComModule.cpp,v 1.5 2000/04/28 19:37:53 chuang Exp $
#pragma warning(disable: 4786)
#include "ComObjectFactory.h"
#include "ComModule.h"

// This is a default module for DLL-based servers.

class DllModule: public ComModule
{
public:
    DllModule ()
    { }
};

static DllModule module;


ComModule *ComModule::ms_pInstance;

ComModule &
ComModule::instance ()
{
    return *ms_pInstance;
}
    
void
ComModule::lock ()
{
    InterlockedIncrement(&m_lockCount);
}

long
ComModule::unlock ()
{
    InterlockedDecrement(&m_lockCount);
    return m_lockCount;
}

void
ComModule::registerFactory (REFCLSID clsid,
                            ComObjectFactory *pFactory)
{
    pFactory->registerFactory(clsid);

    Uuid classId(clsid);
    m_clsidToFactoryMap.insert(ClsidToFactoryMap::value_type(
        classId, pFactory));
}

IClassFactory *
ComModule::find (REFCLSID clsid)
{
    Uuid classId(clsid);
    ClsidToFactoryMap::iterator p = m_clsidToFactoryMap.find(classId);
    if (p != m_clsidToFactoryMap.end()) {
        return p->second;
    }
    return 0;
}

void
ComModule::revokeFactories ()
{
    ClsidToFactoryMap::iterator p = m_clsidToFactoryMap.begin();
    for (; p != m_clsidToFactoryMap.end(); ++p) {
        p->second->revokeFactory();
    }
}
