// $Id: Singleton.h,v 1.2 1999/08/24 00:16:20 chuang Exp $
#ifndef SINGLETON_H
#define SINGLETON_H

#include "mutex.h"

// This class provides thread safe initialization of a singleton.

template<class T>
class Singleton
{
#ifdef TCL_THREADS
    static Tcl_Mutex ms_singletonMutex;
#endif
    static T *ms_pInstance;

public:
    static T &instance();
};

#ifdef TCL_THREADS
template<class T>
Tcl_Mutex Singleton<T>::ms_singletonMutex = 0;
#endif

template<class T>
T *Singleton<T>::ms_pInstance = 0;

template<class T>
T &
Singleton<T>::instance ()
{
    if (ms_pInstance == 0) {
	LOCK_MUTEX(&ms_singletonMutex)
        if (ms_pInstance == 0) {
	    static T singleton;
	    ms_pInstance = &singleton;
        }
    }
    return *ms_pInstance;
}

#endif
