// $Id: TclInterp.h,v 1.3 2000/04/25 22:34:52 chuang Exp $
#ifndef TCLINTERP_H
#define TCLINTERP_H

#include <string>
#include <comdef.h>
#include <tcl.h>

// This class provides access to the Tcl library loaded from a DLL.

class TclInterp
{
    std::string m_rootDir;
    HINSTANCE m_hmodTcl;
    Tcl_Interp *m_interp;

    static TclInterp ms_instance;

    // Do not allow others to create and copy instances of this class.
    TclInterp();

    TclInterp(const TclInterp &);       // not implemented
    void operator=(const TclInterp &);  // not implemented

public:
    ~TclInterp();

#if 0
    // Initialize singleton instance.
    static void initialize();

    // Destroy singleton instance.
    static void destroy();
#endif

    // Get singleton instance.
    static TclInterp &instance();

    // Get directory where Tcl run-time is installed.
    const std::string &rootDir () const
    { return m_rootDir; }

    // Get Tcl interpreter.
    operator Tcl_Interp * ()
    { return m_interp; }
};

#endif
