// $Id: dllmain.cpp,v 1.6 2000/04/28 19:37:53 chuang Exp $
#pragma warning(disable: 4786)
#include "Uuid.h"
#include "ComModule.h"
#include "RegistryKey.h"
#include "TclInterp.h"

#if 0
extern "C" BOOL WINAPI
DllMain (HINSTANCE hinstDll,    // handle to DLL module
         DWORD dwReason,        // reason for calling function
         LPVOID /*lpReserved*/) // reserved
{
    // Perform actions based on the reason for calling.
    switch (dwReason) { 
    case DLL_PROCESS_ATTACH:
        // Do processing when DLL is loaded.
        break;

    case DLL_THREAD_ATTACH:
        // Do thread-specific initialization.
        break;

    case DLL_THREAD_DETACH:
        // Do thread-specific cleanup.
        break;

    case DLL_PROCESS_DETACH:
        // Perform any necessary cleanup.
        break;
    }
    return TRUE;
}
#endif

STDAPI
DllCanUnloadNow (void) 
{
    return (ComModule::instance().lockCount() == 0) ? S_OK : S_FALSE;
}

STDAPI
DllGetClassObject (REFCLSID clsid, 
                   REFIID iid,
                   void **ppv)
{
    try {
        // Use CLSID to find initialize script from registry.
        std::string subkeyName("SOFTWARE\\Scriptics\\Tcl\\tcom\\CLSID\\{");
        Uuid classId(clsid);
        subkeyName += classId.toString();
        subkeyName += '}';
        RegistryKey clsidKey(HKEY_LOCAL_MACHINE, subkeyName);
        std::string script = clsidKey.value("Script");

        // Execute initialize script.
        Tcl_Interp *interp = TclInterp::instance();

        int completionCode = Tcl_EvalEx(
            interp,
            const_cast<char *>(script.data()),
            script.size(),
            TCL_EVAL_GLOBAL);
        if (completionCode != TCL_OK) {
            *ppv = 0; 
            return E_UNEXPECTED;
        }

        IClassFactory *pFactory = ComModule::instance().find(clsid);
        if (pFactory == 0) {
            *ppv = 0; 
            return CLASS_E_CLASSNOTAVAILABLE;
        }
        return pFactory->QueryInterface(iid, ppv);
    }
    catch (...) {
        *ppv = 0; 
        return CLASS_E_CLASSNOTAVAILABLE;
    }
}
