// $Id: nullCmd.cpp,v 1.4 1999/11/17 22:07:38 chuang Exp $
#include <string.h>
#include "nullCmd.h"

// There is no internal representation to duplicate.

static void
nullDupInternalRep (Tcl_Obj *pSrc, Tcl_Obj *pDup)
{ }

// The string representation is the same for all objects of this type.

static char nullStringRep[] = "tcomNULL";

static void
nullUpdateString (Tcl_Obj *pObj)
{
    pObj->length = sizeof(nullStringRep) - 1;
    pObj->bytes = Tcl_Alloc(pObj->length + 1);
    strcpy(pObj->bytes, nullStringRep);
}

// Do not allow conversion from other types.

static int
nullSetFromAny (Tcl_Interp *interp, Tcl_Obj *pObj)
{
    if (interp != NULL) {
        Tcl_AppendResult(interp, "cannot convert to ", nullObjType.name, NULL);
    }
    return TCL_ERROR;
}

Tcl_ObjType nullObjType = {
    nullStringRep,
    NULL,
    nullDupInternalRep,
    nullUpdateString,
    nullSetFromAny
};

// This Tcl command returns a null object which be used to pass a null pointer
// argument.

int
nullCmd (
    ClientData clientData,	/* Not used. */
    Tcl_Interp *interp,		/* Current interpreter. */
    int objc,			/* Number of arguments. */
    Tcl_Obj *CONST objv[])	/* The argument objects. */
{
    if (objc != 1) {
	Tcl_WrongNumArgs(interp, 1, objv, NULL);
	return TCL_ERROR;
    }

    Tcl_Obj *pObj = Tcl_NewObj();
    pObj->typePtr = &nullObjType;

    Tcl_SetObjResult(interp, pObj);
    return TCL_OK;
}
